%global     package_version 3.3.1.0
%global     package_maven_version 3.3.1.0
%global     _javadocname javadoc

%if 0%{?fedora}
%global     install_poms 1
%global     require_maven 1
%global     require_java_dep 1
%global     mvn mvn-rpmbuild
%global     mvnout target
%endif

%if 0%{?rhel}
%global     install_poms 0
%global     require_maven 0
%global     require_java_dep 0
%global     mvn true
%global     mvnout %{_sourcedir}
%endif

Name:           rhevm-sdk-java
Version:        %{package_version}
Release:        1%{?dist}
Summary:        RHEVM Engine Java Software Development Kit
Group:          Development/Libraries
License:        ASL 2.0
URL:            http://www.ovirt.org/Java-sdk

# MEAD: sources are the artifacts previously built with maven:
Source0: rhevm-sdk-java-3.3.1.0-scm-sources.zip
Source1: rhevm-sdk-java-3.3.1.0-javadoc.jar
Source2: rhevm-sdk-java-3.3.1.0-tests.jar
Source3: rhevm-sdk-java-3.3.1.0.jar
Source4: rhevm-sdk-java-3.3.1.0.pom

BuildArch: noarch

BuildRequires:  java-devel
BuildRequires:  jpackage-utils

%if %{require_java_dep}
BuildRequires:  apache-commons-logging
BuildRequires:  apache-commons-compress
BuildRequires:  httpcomponents-httpclient >= 4.2.1
BuildRequires:  junit
BuildRequires:  xerces-j2
%endif

%if %{require_maven}
BuildRequires:  maven
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-source-plugin
%endif

Requires: java
Requires: httpcomponents-httpclient >= 4.2.1
Requires: jakarta-commons-logging
Requires: commons-beanutils
Requires: commons-codec
Requires: log4j

# This package and the corresponding upstream package use the same
# paths and files, so they can't be installed together:
Conflicts: ovirt-engine-sdk-java

%description
This package contains The RHEVM-Engine Java Software Development Kit.
With this package, custom java software can be built for RHEVM-Engine.

%package javadoc
Summary:    Javadocs for %{name}
Group:      Documentation
Requires:   jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep

# MEAD: sources are archived with root based on repository name
%setup -q -T -b 0 -n ovirt-engine-sdk-java

%build
%{mvn} install javadoc:aggregate

%install
install -d -m 755 "%{buildroot}%{_javadir}/%{name}"
install -d -m 755 "%{buildroot}%{_mavenpomdir}"

install -pm 644 "%{mvnout}/%{name}-%{package_maven_version}.jar" "%{buildroot}%{_javadir}/%{name}"
ln -s "%{name}-%{package_maven_version}.jar" "%{buildroot}%{_javadir}/%{name}/%{name}.jar"

%if %{install_poms}
install -pm 644 "pom.xml" "%{buildroot}%{_mavenpomdir}/JPP.%{name}-%{name}.pom"
%add_maven_depmap "JPP.%{name}-%{name}.pom" "%{name}/%{name}.jar"
%endif

mkdir -p "%{buildroot}%{_javadocdir}/%{name}"
install -pm 644 "%{mvnout}/%{name}-%{package_maven_version}-%{_javadocname}.jar" "%{buildroot}%{_javadocdir}/%{name}"
ln -s "%{name}-%{package_maven_version}-%{_javadocname}.jar" "%{buildroot}%{_javadocdir}/%{name}/%{name}-%{_javadocname}.jar"

%files
%{_javadir}/%{name}/
%if %{install_poms}
%{_mavenpomdir}/JPP.%{name}-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%endif
%doc AUTHORS
%doc README
%doc LICENSE

%files javadoc
%{_javadocdir}/%{name}

%changelog
* Fri Jan 24 2014 Juan Hernandez <juan.hernandez@redhat.com> - 3.3.1.0-1
- Don't add parameters with null values #1047638

* Mon Dec 16 2013 Juan Hernandez <juan.hernandez@redhat.com> - 1.0.0.29-1
- Build for Java 1.6 #1043465

* Tue  Dec 10 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.28-1
- to vms.add() added [action.vm.initialization.cloud-init] 
- to NIC added OnBoot/BootProtocol properties
- to VersionCaps added a list of supported payload-encodings

* Tue  Nov 26 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.27-1
- to VnicProfile added Permissions sub-collection #1014985
- from VMSnapshot removed actions: preview, undo, commit #1018554
- to VnicProfilePermission added delete() method overload (with correlation_id)

* Tue  Oct 29 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.26-1
- to host.install() added ssh related details
- to template added virtio_scsi.enabled
- to vm added virtio_scsi.enabled
- added ability to attach a disk snapshot to the virtual machine

* Tue  Oct 22 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.25-1
- to File.java added 'content' filed
- Payload.java now reuses Files instead of own List<PayloadFile> collection

* Tue  Oct 8 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.24-1
- rename /export actions
- added fqdn property to GuestInfo

* Tue  Sep 24 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.23-1
- to Disk added export() action
- Template.exportTemplate() renamed to Template.export()
- VM.exportVM() renamed to VM.export()

* Tue  Sep 17 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.22-1
- refine host add()/update() documentation
- update functions doesn't have overloading methods #1008176
- setupnetworks doesn't work #1008458
- apache PropertyUtilsBean throws NoSuchMethodException #1007266
- session_timeout parameter doesnt exists in API constructor #1007231
- maven compile with jdk 1.7

* Wed  Sep 11 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.21-1
- VCpuPin renamed to VCpuPin
- Host.getRebootAfterInstallation() returns False (null was expected) #985842
- make all sdk exceptions serializable

* Tue  Sep 3 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.20-1
- added StorageDomainStorageConnection.delete() signature
- added StorageDomainStorageConnection.delete(Boolean async) signature
- added StorageDomainStorageConnections.add(StorageConnection storageconnection) signature
- added StorageDomainStorageConnections.add(StorageConnection storageconnection, String expect, String correlationId) signature

* Tue  Aug 27 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.19-1
- add ParameterSet descriptions
- implement AutoCloseable interface
- in Cluster added glusterhooks (ClusterGlusterHooks) sub-collection
- in DataCenterCluster added glusterhooks (DataCenterClusterGlusterhooks)
  sub-collection
- in StorageDomain added images (StorageDomainImages) sub-collection

* Tue  Aug 13 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.18-1
- added VnicProfiles root-collection
- at network added VnicProfiles sub-collection
- at storagedomain added StorageConnections sub-collection
- at VnicProfile added Permission sub-collection
- to network.add()/.updated added [network.profile_required]
- to NICs.add() added new overload with [nic.vnic_profile.id]
- to NIC.update() added new overload with [nic.vnic_profile.id]
- to VMSnapshots.list()/.get() added [String allContent] parameter
- to VMs.add() added new overload based on [vm.initialization.configuration.type|data]

* Tue  Aug 6 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.17-1
- added root collection StorageConnections
- added [host.override_iptables]
- added [template.cpu_shares]
- added [template.display.single_qxl_pci]
- added [vm.display.single_qxl_pci]
- added [vm.cpu_shares]

* Wed  Jul 31 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.16-1
- to template added:
  - [@param template.console.enabled: boolean] #878459
- to vm added:
  - [@param vm.console.enabled: boolean] #878459
- the last character of an error message is truncated #988058

* Thu  Jul 25 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.15-1
- to Cluster added:

    * [@param cluster.comment: string]
    * [@param cluster.ballooning_enabled: boolean]
    * [@param cluster.tunnel_migration: boolean]

- to Host added:

    * [@param host.comment: string]
    * [@param host.ssh.port: int]
    * [@param host.ssh.fingerprint: string]
    * [@param host.ssh.authentication_type: string]
    * [@param host.ssh.password: string]
    * forceselectspm() action

- to Network added:

    * [@param network.comment: string]

- to StorageDomain

    * [@param storagedomain.comment: string]

- to Template added:

    * [@param template.comment: string]
    * [@param template.permissions.clone: boolean]

- to VM added:

    * [@param vm.comment: string]
    * [@param vm.permissions.clone: boolean]

* Tue  Jul 16 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.14-1
- added "watchdog" feature #947977
- added "external tasks" feature #872719
- snapshot can persist/restore memory state now #960931

* Tue  Jul 9 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.13-1
- to cluster.add()/update() added [trusted_service: boolean] property
- move to httpclient 4.2.1
- implement Secure Socket Layer (SSL) host verification (CA certificate)
- allow nullifying headers via passing NULL as header value

* Tue  Jul 2 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.12-1
- deploy: require httpclient >= 4.2
- deploy: require jakarta-commons-logging
- deploy: require log4j

* Thu  Jun 27 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.11-1
- configure log4j programmatically
- require apache-commons-logging instead of commons-logging

* Wed  Jun 26 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.10-1
- to datacenter added new field [comment]
- to disk added [sgio] field to enable|disable filtering for the ScsiGenericIo
- to StorageDomain.delete() added storagedomain.host.id|name

* Thu  Jun 19 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.9-1
- implement basic debugging capabilities
- implement support for the /capabilities resource
- added VMApplications sub-collection to VM
- to cluster.update() added [cluster.data_center.id]
- to host.fence() added action.fence_type
- to storagedomain.delete() added [storagedomain.format]
- to nic added [nic.custom_properties.custom_property]
- to vm.add(), vm.update() added [vm.memory_policy.guaranteed]
- to VmPool added MaxUserVMs property

* Thu  Apr 5 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.7-1
- first rhevm-sdk-java branded release
- updated storagedomain add()/update() docs
- updated tag update() docs
- enable correct generation of Boolean getters/setters
  to enable Bean Introspection apis (bollean getters will
  be prefixed with getX())
- fixed docs for GlusterBricks add|update
- fixed docs for add|update Tag
- added [network.usages.usage] to ClusterNetworks
- in add TemplateNICs, network.id|name is no longer mandatory
- StorageDomainVM can be removed asynchronously now
- removed DataCenterQuota.add|delete (yet not supported)

* Thu  Apr 4 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.6-1
- added new collection ClusterGlusterVolumeGlusterBrickStatistics
- added new properties to the GlusterBrick
- to vm added cpu.mode
- to host install action added "image" parameter
- ignore case in factory method lookup

* Thu  Mar 7 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.5-1
- use explicit classloader for JAXBContext
- implement support for (user defined) session authentication
- implement generic JAXBElement generation
- to DataCenterStorageDomain added Disks sub-collection
- to StorageDomain added Disks sub-collection
- to host added display.address property
- to vms.add() added overload for creating vm from snapshot

* Sun  Feb 24 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.4-1
- implement SSL support (without host verification)
- implement shutdown() to deallocate system resources
- to cluster added tunnel_migration property
- to DataCenter added Clusters sub-collection
- to root collection resource Disk added Permissions sub-collectio
- to root collection resource Disk added Statistic sub-collection
- host can be attached to cluster now either by id or name
- to StorageDomainTemplate added Disks sub-collection
- to StorageDomainVM added Disks sub-collection
- to template.display added keyboard_layout property
- to template added tunnel_migration property
- to vm.display added keyboard_layout property
- to vm added tunnel_migration property
- to VMSnapshot added preview method
- to VMSnapshot added undo method
- to VMSnapshot added commit method

* Wed  Jan 30 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.3-1
- added persistent authentication support
- added support for the method overloads based on url/headers params
- added delete methods overloads with body as parameters holder
- to host added overrideable [display.address] property
- user can specify own ticket now in vm.ticket() via [action.ticket.value]

* Wed  Jan 16 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.2-1
- in vm/vmnic device property renamed to reportedDevice
- to host added libvirtVersion
- addresses an issue when API constructor when NULLs used as parameters

* Tue Jan  15 2013 Michael Pasternak <mpastern@redhat.com> - 1.0.0.1-1
- implement parametrized list() methods
- events can be added now (user defined events)
- events can be removed now
- host can be added now by using cluster.name (not only cluster-id)
- NIC now has "linked" property
- NIC now has "plugged" property
- VM has now ReportedDevices sub-collection
- VMNIC has now ReportedDevices sub-collection
- to host add/update added power_management.agents parameter
- to disk added permissions sub-collection
- to PowerManagement added Agents collection
- to VMDisk added move() action
- to host added hooks sub-collection
- to cluster added threads_as_cores property
- to host added hardwareInformation property
- to host added OS property
- added force flag to the host.delete() method
- added host.power_management.pm_proxy sub-collection
- added permissions sub-collection to the network
- added search capabilities to api.networks collection
- added deletion protection support to template/vm via .delete_protected property

* Sun Dec 2 2012 Michael Pasternak <mpastern@redhat.com> - 1.0.0.1-1
- Initial Import
